
#include "adc.h"

#define ADC1_DR_Address    ((u32)0x4001244C)

__IO u16 ADC_ConvertedValue;

/*
 * ADC1_GPIO_Config
 *   ʹADC1ʱӣʼPA.01
 *   : 
 *   
 *   ڲ
 */
static void ADC1_GPIO_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;

	/* Enable ADC1 and GPIOC clock */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1 | RCC_APB2Periph_GPIOA, ENABLE);
	
	RCC_ADCCLKConfig(RCC_PCLK2_Div6);   //72M/6=12,ADCʱ䲻ܳ14MδҵͶƵ

  /* Configure PA.01  as analog input */
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1|GPIO_Pin_2|GPIO_Pin_3|GPIO_Pin_4;
  //GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0|GPIO_Pin_1;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
  GPIO_Init(GPIOA, &GPIO_InitStructure);				// PB0,ʱ
}


/* ADC1_Mode_Config
 *   ADC1Ĺģʽ
 *   : 
 *   
 *   ڲ
 */
static void ADC1_Mode_Config(void)
{
	ADC_InitTypeDef ADC_InitStructure;

	/* Resets ADC1 */ 
	ADC_DeInit(ADC1);  // ADC1 ȫĴΪȱʡֵ
	
	/* ADC1 configuration ------------------------------------------------------*/
	ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;	//ADCģʽ:ADC1ADC2ڶģʽ
	ADC_InitStructure.ADC_ScanConvMode = DISABLE;	//ģתڵͨģʽ
	ADC_InitStructure.ADC_ContinuousConvMode = DISABLE;	//ģתڵתģʽ
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;	//תⲿ
	ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;	//ADCҶ
	ADC_InitStructure.ADC_NbrOfChannel = 1;	//˳йתADCͨĿ
	ADC_Init(ADC1, &ADC_InitStructure);	//ADC_InitStructָĲʼADCxļĴ
	
	/* Enable ADC1 */
	ADC_Cmd(ADC1, ENABLE);	//ʹָADC1
	
	
	/* Enable ADC1 reset calibaration register */   
	ADC_ResetCalibration(ADC1);	//ָADC1У׼Ĵ
	/* Check the end of ADC1 reset calibration register */
	while(ADC_GetResetCalibrationStatus(ADC1));	//ȡADC1У׼Ĵ״̬,״̬ȴ
	
	/* Start ADC1 calibaration */
	ADC_StartCalibration(ADC1);		//ʼָADC1У׼״̬
	/* Check the end of ADC1 calibration */
	while(ADC_GetCalibrationStatus(ADC1));		//ȡָADC1У׼,״̬ȴ
	
	/* Start ADC1 Software Conversion */ 
	ADC_SoftwareStartConvCmd(ADC1, ENABLE);		//ʹָADC1ת
}

/*
 * ADC1_Init
 *   
 *   
 *   
 *   ⲿ
 */
void ADC1_Init(void)
{
	ADC1_GPIO_Config();
	ADC1_Mode_Config();
}

//ADCֵ
//ch:ֵͨ 0~3
u16 Get_Adc(u8 ch)   
{
  	//ָADCĹͨһУʱ
	ADC_RegularChannelConfig(ADC1, ch, 1, ADC_SampleTime_239Cycles5 );	//ADC1,ADCͨ,ʱΪ239.5	  			    
  
	ADC_SoftwareStartConvCmd(ADC1, ENABLE);		//ʹָADC1ת	
	 
	while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC ));//ȴת

	return ADC_GetConversionValue(ADC1);	//һADC1ת
}


