
/*
**************************************************************************************************
*	   СƵӿƼ
* ļstm321602Դļ
*   
* 汾ţV2.0
*   ע
* ԱӼ
*   ڣ2018-04-22
***************************************************************************************************
*/

#include "drive_lcd1602.h"
#include "delay.h"
#include "stm32f10x.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_rcc.h"
#include <stdarg.h>		  //  ׼ͷļ
#include "stdio.h"

#ifdef LCD602_Bin  //
/*Ϊ*/
///********************************Ӳӿڶ*********************************/
#define RS  GPIO_Pin_7             
#define RW  GPIO_Pin_6 
#define EN  GPIO_Pin_5 
#define Control_GPIO GPIOA 

/********************************궨*********************************/
#define    LCD1602_RS(x)  x ? GPIO_SetBits(Control_GPIO, RS): GPIO_ResetBits(Control_GPIO, RS)
#define    LCD1602_RW(x)  x ? GPIO_SetBits(Control_GPIO, RW): GPIO_ResetBits(Control_GPIO, RW)
#define    LCD1602_EN(x)  x ? GPIO_SetBits(Control_GPIO, EN): GPIO_ResetBits(Control_GPIO, EN)
void LCDGPIO_Configuration(void);

/********************************************************************* 
*    ƣLcdWaitReady()
*    ȴҺ׼
*ڲ
*ڲresult
*********************************************************************/
u8 LcdWaitReady(void)
{                         // LCDæµ״̬
	u8 result;
	LCD1602_RS(0);  //0;
	LCD1602_RW(1);  //1;
	LCD1602_EN(1);  //1;
	delay_us(50);
	result = (GPIO_ReadInputData(GPIOB) & 0x8000)>>8;
	LCD1602_EN(0); // 0;
	return result; 
}
/********************************************************************* 
*    : LcdWriteCmd(u8 cmd)
*    дָLCD1602,ָռһֽ
*ڲcmd,дָ
*ڲ
*********************************************************************/
void LCD1602_Write_Cmd(unsigned char cmd)  
{                          // дָݵLCD
	//while(LcdWaitReady());
	delay_us(500);
	LCD1602_RS(0); // 0;
	LCD1602_RW(0); // 0;
	LCD1602_EN(0); // 0;
	delay_us(50);
	GPIOB->BSRR = cmd<<8 & 0xff00;  //͵P0 
  GPIOB->BRR = ((~cmd)<<8) & 0xff00;
	delay_us(50);
	LCD1602_EN(1); // 1;
	delay_us(50);
	LCD1602_EN(0); // 0;  
}

/********************************************************************* 
*    : LcdWriteCmd(u8 cmd)
*    дݵLCD1602,ռһֽ
*ڲdat,д
*ڲ
*********************************************************************/
void LCD1602_Write_Dat(unsigned char dat) 
{                          //дַʾݵLCD
	//while(LcdWaitReady());
	delay_us(500);
	LCD1602_RS(1); //= 1;
	LCD1602_RW(0); //= 0;
	LCD1602_EN(0); //= 0;
	GPIOB->BSRR = dat<<8 & 0xff00;    ////P0 = dat
  GPIOB->BRR = ((~dat)<<8) & 0xff00;
	delay_us(50);
	LCD1602_EN(1);// = 1;
	delay_us(50);
	LCD1602_EN(0);// = 0; 
	delay_us(50);
}
/********************************************************************* 
*    ƣInitLcd1602()
*    ʼ1602Һ 
*ڲ
*ڲ
*********************************************************************/	
void Init_Lcd1602(void)
{           
	//LCDʼ趨
	LCDGPIO_Configuration();
	delay_ms(100);
	LCD1602_Write_Cmd(0x38);          //16*2ʾ5*78λ
	delay_ms(30);
	LCD1602_Write_Cmd(0x0c);          //ʾع
  delay_ms(30);
	LCD1602_Write_Cmd(0x06);          //ƶ
	delay_ms(30);
	LCD1602_Write_Cmd(0x01);          //LCDʾ
	delay_ms(30);
}
/********************************************************************* 
*    ƣLcdClearScreen()
*    
*ڲ
*ڲ
*********************************************************************/
void LcdClearScreen(void)
{
	LCD1602_Write_Cmd(0x01);
}

/********************************************************************* 
*    ƣLcdOpenCursor()
*    򿪹˸Ч 
*ڲ
*ڲ
*********************************************************************/
void LcdOpenCursor(void)
{
	LCD1602_Write_Cmd(0x0F);
}

/********************************************************************* 
*    ƣLcdCloseCursor()
*     رչʾ 
*ڲ
*ڲ
*********************************************************************/
void LcdCloseCursor(void)
{
	LCD1602_Write_Cmd(0x0C);
}


void LCDGPIO_Configuration(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
	
	  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);
	
	  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);//RS RW EN ƽ ʱ
	  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_All;
	  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	  GPIO_Init(GPIOB,&GPIO_InitStructure);
		GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 |GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15; 
	   //GPIOΪͬһͶ˿
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_OD;	 //©
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;	 //ƵΪ50HZ
		GPIO_Init(GPIOB, &GPIO_InitStructure);   //ʼGPIOB˿
	
	  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7|GPIO_Pin_6|GPIO_Pin_5;
	  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	  GPIO_Init(Control_GPIO,&GPIO_InitStructure);
}
#else	

//1602ָ/   rs
#define LCD_RS_Set()    GPIO_SetBits(GPIOB, GPIO_Pin_7)  
#define LCD_RS_Clr()    GPIO_ResetBits(GPIOB, GPIO_Pin_7)  
  
//1602д  rwԲ ֱӽӵ 
#define LCD_RW_Set()    GPIO_SetBits(GPIOB, GPIO_Pin_6)  
#define LCD_RW_Clr()    GPIO_ResetBits(GPIOB, GPIO_Pin_6)  
  
//1602ʹ  en
#define LCD_EN_Set()    GPIO_SetBits(GPIOB, GPIO_Pin_6)  
#define LCD_EN_Clr()    GPIO_ResetBits(GPIOB, GPIO_Pin_6)  
 

//1602ݶ˿  PD4~7  //òһioдʹ  
#define DATAOUT(x)  GPIO_Write(LCD_DATA_PORT, x)  
#define LCD_DATA_PORT GPIOB 


void LCDGPIO_Configuration(void) 
{  
    GPIO_InitTypeDef    GPIO_InitStructure;  
      
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB|RCC_APB2Periph_GPIOA,ENABLE);//ʱ  
       //dataIO GPIOA4~7 ʼ  
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12|GPIO_Pin_13|GPIO_Pin_14|GPIO_Pin_15;  
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;      
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;     
    GPIO_Init(LCD_DATA_PORT, &GPIO_InitStructure);                
        // RS RW E IOʼ  
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7|GPIO_Pin_6|GPIO_Pin_5;  //rw rs en 
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;      
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;     
    GPIO_Init(GPIOB, &GPIO_InitStructure);                
}  
  
/* Һææ */  
void LCD1602_Wait_Ready(void)  
{  
    int8_t sta;  
    DATAOUT(0xff);    //PA˿ȫ1  
    LCD_RS_Clr();     //RS 0  
    LCD_RW_Set();     //RW 1  
    do  
    {  
        LCD_EN_Set();   //EN 1  
        delay_ms(5);    //ʱ5MS  
        sta = GPIO_ReadInputDataBit(GPIOB,GPIO_Pin_15);//ȡ״̬  
        LCD_EN_Clr();  //EN  0  
    }while(sta & 0x80);//bit71ʾæ,ظ⵽Ϊ0ֹͣ  
}  
/*
1602дһֽ,cmd-д 
//дָ RS-0  RW-0  
*/  

void LCD1602_Write_Cmd(unsigned char cmd)  
{  
	  char ik=0;
	  delay_ms(10);    //æź ʱ  
    //LCD1602_Wait_Ready();  //жææ  
    LCD_RS_Clr();     

	    for(ik=0;ik<2;ik++) //һλһλдݽȥ  д  Ӱλ
			{
				   LCD_EN_Set();
					 GPIO_ResetBits(GPIOB,GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15);//ݿȫд
					if(cmd&0x80)  GPIO_SetBits(GPIOB,GPIO_Pin_15); 
					if(cmd&0x40)  GPIO_SetBits(GPIOB,GPIO_Pin_14);
					if(cmd&0x20)  GPIO_SetBits(GPIOB,GPIO_Pin_13);
					if(cmd&0x10)  GPIO_SetBits(GPIOB,GPIO_Pin_12);
					LCD_EN_Clr();  
					cmd=cmd<<4;
      }
}  
  
/* 1602дһֽ*/  
void LCD1602_Write_Dat(unsigned char dat)  
{  
	     char ik=0;
	    delay_ms(10);    //æź ʱ 
      LCD_RS_Set();   //1   
		  for(ik=0;ik<2;ik++)
			{
				   LCD_EN_Set();
					GPIO_ResetBits(GPIOB,GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15);
					if(dat&0x80)  GPIO_SetBits(GPIOB,GPIO_Pin_15);
					if(dat&0x40)  GPIO_SetBits(GPIOB,GPIO_Pin_14);
					if(dat&0x20)  GPIO_SetBits(GPIOB,GPIO_Pin_13);
					if(dat&0x10)  GPIO_SetBits(GPIOB,GPIO_Pin_12);
					LCD_EN_Clr();  
					dat=dat<<4;
       }
}  
/* ʼҺ*/  
void Init_Lcd1602(void)  
{  
	  LCDGPIO_Configuration();//IOóʼ
    LCD1602_Write_Cmd(0x28);    //16*2ʾ5*74λݿ  
    LCD1602_Write_Cmd(0x0C);    //ʾر  
    LCD1602_Write_Cmd(0x06);    //ֲַԶ+1  
    LCD1602_Write_Cmd(0x01);    //  
}  

#endif

/************ дַݺ  *****************
//ܣlcd1602ָλʾַ
//
//p:    ָʾָ
//x:    X
//y:    Y
*/
void WriteLcd1602_String(char x,char y,char  *p)
{
  if(y == 0)
	{
     LCD1602_Write_Cmd(0x80 + x);    
	}
	else
	{
      LCD1602_Write_Cmd(0xC0 + x);
  }
	while(*p != 0)
	{
        LCD1602_Write_Dat(*p);
		    p++;
  }
}
void L1602_printf(char x,char y,char *p,...)
{
	  char Lcdbuf[16];
		va_list ap;
		va_start(ap,p);
		vsprintf(Lcdbuf,p,ap);
		va_end(ap);
		WriteLcd1602_String(x,y,Lcdbuf);
}

