#include "stm32f10x.h" 
#include "delay.h"
#include "math.h"
#include "time_init.h"
#include "stdlib.h"
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "drive_lcd1602.h"
#include "adc.h"

#include "usart.h"

u8 SENDTimer=0;


int key_Read(void);


void RCC_Configuration(void)
{
   SystemInit();
}

/**
  * @brief  Main program.
  * @param  None
  * @retval : None
  */

void LED_Init(void)
{
 
 GPIO_InitTypeDef  GPIO_InitStructure;
 	
 RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);	 //ʹPB,PE˿ʱ
	
 GPIO_InitStructure.GPIO_Pin = GPIO_Pin_13;				 //LED0-->PB.5 ˿
 GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 //
 GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		 //IOٶΪ50MHz
 GPIO_Init(GPIOC, &GPIO_InitStructure);					 //趨ʼGPIOB.5
 //GPIO_SetBits(GPIOA,GPIO_Pin_15);						 //PB.5 
 GPIO_ResetBits(GPIOC,GPIO_Pin_13);
}



void TIM4_IRQHandler() //10ms 1
{					  
	static u8 tsec; u8 st;
	//static u8 key_Timer=0;
	st=TIM_GetFlagStatus(TIM4, TIM_IT_Update);
	SENDTimer++;
	if(st!=0)
	{  
		TIM_ClearFlag(TIM4, TIM_IT_Update); 
//    pid.C10ms++;
		if(tsec++>=100)
		{
		  tsec=0;

		}
		key_Read();
	}
}

void Isr_Init(void)
{
	  NVIC_InitTypeDef NVIC_InitStructure; 
			
		NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
		NVIC_InitStructure.NVIC_IRQChannel =TIM4_IRQn;// TIM4_IRQChannel; 
		NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1; 
		NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1; 
		NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; 
		NVIC_Init (&NVIC_InitStructure); 
	
}

/***************************************************************
** ܣİ尴˿ڳʼ
** 
** ֵ
****************************************************************/
void key_Init(void)
{
		 GPIO_InitTypeDef GPIO_InitStructure;
	   RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);
		 GPIO_InitStructure.GPIO_Pin=GPIO_Pin_0|GPIO_Pin_1;
		 GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;//ģʽ
		 GPIO_Init(GPIOB,&GPIO_InitStructure);
}

char Ifg=0;

char Gear=0;

char clearFlag=0;

/***************************************************************
** ܣɨ
** 
** ֵɨʱ
****************************************************************/
int key_Read(void)
{
	 u16 key_value;
	 static u8 key_up=0;
   key_value = GPIO_ReadInputData(GPIOB);
	 key_value &=0x0003;
	 if(key_value!=0x0003)
	 {
		 if(key_up==0)
		 {
			 key_up=1;
		   switch(key_value)
		   {
			   case 0x0002:						
				   if(++Ifg>3)
					 {
					    Ifg=0;
					 }
					 Gear=0;
					 clearFlag=1;
					
				 break;
				 case 0x0001:			
        	if(Ifg==2)
						{
								Gear++;
								if(Gear>=4)
								{
									 Gear=0;
								}
						}
						else 
						{
								Gear++;
							 if(Gear>=2)
								{
									 Gear=0;
								}
						}	 
			clearFlag=1;
				 break;
		   }
	   }
	 }
	 else key_up=0;
   
	 return 1;
}

#define Nx 11
u16 value_buf[Nx];
int Rx_count=0;

/*****************************************************
  FILTER_median
    λֵ˲N(Nȡ)
	NβֵСУȡмֵΪЧֵ
	÷ΧЧ˷żȻĲţ
	¶ȡҺλı仯ıõ˲Ч
	ٶȵȿٱ仯Ĳˡ
	
  λֵƽ˲Nݣȥһֵ
	һСֵȻN-2ݵƽֵ
	÷ΧӦżȻֵԸţ
	ĲֵƫǲٶȽ, Ƚ˷RAM
	
  ֵFlagѡλֵ˲λֵƽ˲
	  ONλֵƽ˲  OFFλֵ˲
  ֵ˲
	עλֵ˲NȡN=2^xη+1 Ϊ
				λֵƽ˲N=2^xη+2 Ϊ
 ******************************************************/
u16 FILTER_median(char Flag,char Ad)	//λֵ˲   λֵƽ˲  NΪȡ  Flag:λֵƽ˲ʹ
{
	  u16 temp=0;			
		long sum=0;
		int count,i,j;
		for (count=0;count<Nx;count++)
		{
				value_buf[count] =Get_Adc(Ad);
			  delay_ms(2)	;										//ȴADת
		}
		for(j=0;j<Nx-1;j++)  									//
			{
				for(i=0;i<Nx-j-1;i++)	
					{
						if ( value_buf[i] > value_buf[i+1] )
							{
								temp =	value_buf[i];
								value_buf[i] = value_buf[i+1];
								value_buf[i+1] = temp;
							}
					}
			}
    if(Flag)
		{
		  for(count=1;count<Nx-1;count++)				//λƽ Flag־
			sum+=value_buf[count];
			return (sum/(Nx-2));
		}
   else 
		return value_buf[(Nx-1)/2];						//λֵ
 }

 
float Vcc_Data=0;

void GetVcc_Values(void)//õԴѹֵ 
{
	 u16 Udata=0;
	//Udata=Get_Adc(3);
	 Udata=FILTER_median(1,3);//ȡ׼ѹֵ 3ͨ
   Vcc_Data=(float)(4096*2500.0)/Udata;//Դѹ 
}

void Get_DCV_ACV_RES(void)
{
	u16 adc1=0;
	float ad_val=0;
	long ZsData=0;
	char Show_Buff[16]={0};
	long sum=0;
	int count,i,j;
  switch(Ifg)
	{
	  case 0:
				 if(Gear==0)
				 {
					 adc1=FILTER_median(1,0);//ȡ1ͨ  λֵ˲
					if(adc1>10)
					{
					   ad_val=(adc1*Vcc_Data)/4096;
						 
						 ad_val*=11.2;
						 ad_val/=1000;
						if(ad_val>25)ad_val=24.99;
					}
					  sprintf(Show_Buff,"%6.2fV",ad_val);
			          WriteLcd1602_String(0,0,"  DCV  0-25V     ");
					  WriteLcd1602_String(0,1,"Value:");
					  WriteLcd1602_String(6,1,Show_Buff);
				 }
				  if(Gear==1)
				 {
					 adc1=FILTER_median(1,0);//ȡ1ͨ  λֵ˲
					if(adc1>10)
					{
					   ad_val=(adc1*Vcc_Data)/4096;
						 
						 ad_val*=110;
						 ad_val/=1000;
						 if(ad_val>250)ad_val=249.99;
					}
					  sprintf(Show_Buff,"%6.2fV",ad_val);
			      WriteLcd1602_String(0,0,"  DCV  0-250V    ");
					  WriteLcd1602_String(0,1,"Value:");
					  WriteLcd1602_String(6,1,Show_Buff);
				 }
		break;
				 
	   case 1:
				 if(Gear==0)
				 {
					 adc1=FILTER_median(1,1);//ȡ1ͨ  λֵ˲
					if(adc1>10)
					{
					   ad_val=(adc1*Vcc_Data)/4096;
						 ad_val/=10;
						 if(ad_val>200)ad_val=199.99;
					}
					  sprintf(Show_Buff,"%6.2fmA",ad_val);
			      WriteLcd1602_String(0,0,"  DCA  0-200mA  ");
					  WriteLcd1602_String(0,1,"Value:");
					  WriteLcd1602_String(6,1,Show_Buff);
				 }
				  if(Gear==1)
				 {
					 adc1=FILTER_median(1,1);//ȡ1ͨ  λֵ˲
					if(adc1>10)
					{
					   ad_val=(adc1*Vcc_Data)/4096;
						 ad_val/=1000;
						 if(ad_val>2)ad_val=1.99;
					}
					  sprintf(Show_Buff,"%6.2fA ",ad_val);
			      WriteLcd1602_String(0,0,"  DCA  0-2A     ");
					  WriteLcd1602_String(0,1,"Value:");
					  WriteLcd1602_String(6,1,Show_Buff);
				 }
		break;
		
		case 3:
    sum=0;
		for (count=0;count<500;count++)
		{
				sum +=Get_Adc(4);
			  delay_ms(2);										//ȴADת
		}
		adc1 = sum/500;
					// adc1=FILTER_median(1,4);//ȡ2ͨ  λֵ˲
					if(adc1>20)
					{
					   ad_val=(adc1*Vcc_Data)/4096;
					   ad_val*=901;//Ի˥ õʵʵѹ
             ad_val/=1000;
						 
					}
					  sprintf(Show_Buff,"%6.1fV",ad_val);
			      WriteLcd1602_String(0,0,"  ACV  0-250V    ");
					  WriteLcd1602_String(0,1,"Value:");
					  WriteLcd1602_String(6,1,Show_Buff);
	
		break;
		
		case 2:
				 if(Gear==0)
				 {
			     adc1=FILTER_median(1,2);//ȡ0ͨ  λֵ˲
					if(adc1>20)
					{
					   ad_val=(adc1*Vcc_Data)/4096;
						 ad_val=(ad_val*2000)/(Vcc_Data-ad_val);//ֵ Ӳ·Ʋõıԭ 
                                             //	֮ĹϵóĹʽ  U1/U2=R1/R2
						 if(ad_val>2000)ad_val=1999.9;
					}
            sprintf(Show_Buff,"%6.1f",ad_val);
			      WriteLcd1602_String(0,0,"  RES  0-2000    ");
					  WriteLcd1602_String(0,1,"Value:");
					  WriteLcd1602_String(6,1,Show_Buff);
				 }
				  if(Gear==1)
				 {
			     adc1=FILTER_median(1,2);//ȡ0ͨ  λֵ˲
					if(adc1>20)
					{
					   ad_val=(adc1*Vcc_Data)/4096;
						 ad_val=(ad_val*2000)/(Vcc_Data-ad_val);//ֵ Ӳ·Ʋõıԭ 
              ad_val/=100;                               //	֮ĹϵóĹʽ  U1/U2=R1/R2
						 if(ad_val>20)ad_val=19.9;
					}
            sprintf(Show_Buff,"%6.1fk",ad_val);
			      WriteLcd1602_String(0,0,"  RES  0-20K    ");
					  WriteLcd1602_String(0,1,"Value:");
					  WriteLcd1602_String(6,1,Show_Buff);
				}
				 if(Gear==2)
				 {
				  adc1=FILTER_median(1,2);//ȡ0ͨ  λֵ˲
					if(adc1>20)
					{
					   ad_val=(adc1*Vcc_Data)/4096;
						 ad_val=(ad_val*2000)/(Vcc_Data-ad_val);//ֵ Ӳ·Ʋõıԭ 
              ad_val/=10;                               //	֮ĹϵóĹʽ  U1/U2=R1/R2
						 if(ad_val>200)ad_val=199.9;
					}
            sprintf(Show_Buff,"%6.1fk",ad_val);
			      WriteLcd1602_String(0,0,"  RES  0-200K   ");
					  WriteLcd1602_String(0,1,"Value:");
					  WriteLcd1602_String(6,1,Show_Buff);
				}
				  if(Gear==3)
				 {
				  adc1=FILTER_median(1,2);//ȡ0ͨ  λֵ˲
					if(adc1>20)
					{
					   ad_val=(adc1*Vcc_Data)/4096;
						 ad_val=(ad_val*2000)/(Vcc_Data-ad_val);//ֵ Ӳ·Ʋõıԭ 
             ad_val/=1000;                               //	֮ĹϵóĹʽ  U1/U2=R1/R2
						 if(ad_val>2)ad_val=1.99;
					}
            sprintf(Show_Buff,"%5.2fM",ad_val);
			      WriteLcd1602_String(0,0,"  RES  0-2M   ");
					  WriteLcd1602_String(0,1,"Value:");
					  WriteLcd1602_String(6,1,Show_Buff);
				}
		break;

	}

}
char showBuff[2]={0};

int main(void)
{
    ADC1_Init();
	delay_init();
	uart_init(9600);
	LED_Init();
	Timer4_init()	;//T4 10msʱ
	Isr_Init();
	key_Init();
	Init_Lcd1602();
	
	while(1)
	{
		 if(clearFlag)
		 {
			  clearFlag=0;
		    LCD1602_Write_Cmd(0x01);//Ļ
			  delay_ms(20);
		 }
     GetVcc_Values();
		 Get_DCV_ACV_RES();
		 delay_ms(500);
		   
  }
	
}